/*
 * @Copyright (c) 2018 缪聪(mcg-helper@qq.com)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");  
 * you may not use this file except in compliance with the License.  
 * You may obtain a copy of the License at  
 *     
 *     http://www.apache.org/licenses/LICENSE-2.0  
 *     
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" BASIS,  
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
 * See the License for the specific language governing permissions and  
 * limitations under the License.
 */

package com.mcg.util;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public class DateUtils {

	public final static  String DEFAULT_FORMAT = "yyyy-MM-dd HH:mm:ss";
	
    public static String format(Date date) {
        final DateFormat df = new SimpleDateFormat(DEFAULT_FORMAT);
        return df.format(date);
    }
	
    public static String format(Date date, String pattern) {
    	if(pattern == null || "pattern".equals(pattern)) {
    		pattern = DEFAULT_FORMAT;
    	}
        final DateFormat df = new SimpleDateFormat(pattern);
        return df.format(date);
    }
    
}
